import './App.css';
import 'bootstrap/dist/css/bootstrap.min.css';

import { useState,useEffect,Fragment } from 'react';

import Container from 'react-bootstrap/Container';
import Row from 'react-bootstrap/Row';
import Col from 'react-bootstrap/Col';
import Navbar from 'react-bootstrap/Navbar';
import Button from 'react-bootstrap/Button';
import ProgressBar from 'react-bootstrap/ProgressBar';
import Accordion from 'react-bootstrap/Accordion';
import ToastContainer from 'react-bootstrap/ToastContainer'
import Toast from 'react-bootstrap/Toast'
import Nav from 'react-bootstrap/Nav'
import Spinner from 'react-bootstrap/Spinner';
import Form from 'react-bootstrap/Form';

import { FaCheckCircle } from 'react-icons/fa';
import { BiAlarmAdd } from 'react-icons/bi';
import { MdAlarmOff } from 'react-icons/md';

const fuzzysort = require('fuzzysort')


const parse = require('csv-parse/lib/sync')
const axios = require('axios');

const dataSplitters = [0,186,453,657]

const BACKEND_URL = "https://projectdivar.com:4505"

const NOTIFICATIONTIMEOUT = 300 //In seconds

const progress1 = new Audio(process.env.PUBLIC_URL+"/progress1.mp3")
const progress2 = new Audio(process.env.PUBLIC_URL+"/progress2.mp3")

const retainerNames = ["Ayayayaya","Kittystorage","Morecatz","Finalretainer","Nowitsabun","Butwhy","Kkittyy","Howdoesanyonenameall","Ayayayayay"];

function Item(p){
	const {item,contributor,itemCount,totalItemCount,playerInventory} = p
	const [itemLoc,setItemLoc]=useState("")
	const [itemTimers,setItemTimers]=useState([])
	const [lockout,setLockout]=useState(false)

	function updateTimer(ts,te,timerIndex) {
		var newTimerStart=[];
		if (item.timer_start!==null){
			newTimerStart=[...item.timer_start.split(",")];
		}
		var newTimerEnd=[];
		if (item.timer_end!==null){
			newTimerEnd=[...item.timer_end.split(",")];
		}
		if (ts==""&&te==""){
			newTimerStart=newTimerStart.filter((item,i)=>i!=timerIndex);
			newTimerEnd=newTimerEnd.filter((item,i)=>i!=timerIndex);
		} else {
			newTimerStart[timerIndex]=ts;
			newTimerEnd[timerIndex]=te;
		}
		setLockout(true)
		axios.post(BACKEND_URL+"/updateTimer",{timer_start:newTimerStart.join(","),timer_end:newTimerEnd.join(","),id:item.id,last_modified:new Date()})
		.then((data)=>{
			setLockout(false)
		})
		.catch((err)=>{
			setLockout(false)
		})
	}

	function updateItem(item,target,contributor) {
		var correctedVal=Math.min(item.required,target.value);
		if (correctedVal===Number(item.obtained)) {return;}
		setLockout(true)
		axios.post(BACKEND_URL+"/updateItem",{obtained:correctedVal,id:item.id,last_modified:new Date(),item_name:item.name,username:contributor,required:item.required,operation:correctedVal===Number(item.required)?"FINISH":correctedVal>item.obtained?"INCREASE":"SET",previous_amt:item.obtained,itemCount:itemCount,totalItemCount:totalItemCount,finalcraft:item.finalcraft})
		.then((data)=>{
			setLockout(false)
		})
		.catch((err)=>{
			setLockout(false)
		})
	}

	useEffect(()=>{
		let locObj={};
		let locs="";
		for (var i=0;i<playerInventory.length;i++){
			var ind = playerInventory[i]
			for (var j=0;j<ind.length;j++){
				var it = ind[j]
				if (it.id==item.itemid){
					switch(i){
						case 0:{
							if (locs.length!=0){locs+=","}
							if (j<140){
								if ("Player" in locObj){
									var tempItem = locObj["Player"]
									if (it.hq===true){
										tempItem.amtHQ+=it.amt
									} else {
										tempItem.amt+=it.amt
									}
									tempItem.page=Math.floor(j/35+1)
									locObj["Player"]={...tempItem}
								} else {
									var tempItem = {...it}
									tempItem.amt=0
									tempItem.amtHQ=0
									if (it.hq===true){
										tempItem.amtHQ+=it.amt
									} else {
										tempItem.amt+=it.amt
									}
									tempItem.page=Math.floor(j/35+1)
									tempItem.index=j
									locObj["Player"]={...tempItem}
								}
							} else {
								if ("Saddlebag" in locObj){
									var tempItem = locObj["Saddlebag"]
									if (it.hq===true){
										tempItem.amtHQ+=it.amt
									} else {
										tempItem.amt+=it.amt
									}
									tempItem.page=Math.floor((j-140)/35+1)
									locObj["Saddlebag"]={...tempItem}
								} else {
									var tempItem = {...it}
									tempItem.amt=0
									tempItem.amtHQ=0
									if (it.hq===true){
										tempItem.amtHQ+=it.amt
									} else {
										tempItem.amt+=it.amt
									}
									tempItem.page=Math.floor((j-140)/35+1)
									locObj["Saddlebag"]={...tempItem}
								}
							}
						}break;
						default:{
							if (String(retainerNames[i-1]) in locObj){
								var tempItem = locObj[String(retainerNames[i-1])]
								if (it.hq===true){
									tempItem.amtHQ+=it.amt
								} else {
									tempItem.amt+=it.amt
								}
								tempItem.page=Math.floor(j/35+1)
								locObj[String(retainerNames[i-1])]={...tempItem}
							} else {
								var tempItem = {...it}
								tempItem.amt=0
								tempItem.amtHQ=0
								if (it.hq===true){
									tempItem.amtHQ+=it.amt
								} else {
									tempItem.amt+=it.amt
								}
								tempItem.page=Math.floor(j/35+1)
									locObj[String(retainerNames[i-1])]={...tempItem}
							}
						}
					}
				}
			}
		}
		for (var key of Object.keys(locObj)){
			var it=locObj[key]
			if (locs.length>0){locs+=","}
			locs+=key+" ["+it.page+"] "+((it.amtHQ>0)?("HQx"+it.amtHQ):"")+((it.amt>0)?(((it.amtHQ>0)?"|":"")+"x"+it.amt):"")
			//locs+="Player Inventory ["+Math.floor((j/35+1))+"] x"+it.amt
		}
		setItemLoc(locs)
		if (item.required!==item.obtained&&item.timer_start!==null&&item.timer_start.length>0&&item.timer_start[0]!=""){
			var endTimers = item.timer_end.split(",");
			setItemTimers(item.timer_start.split(",").map((t,i)=>{return {timer_start:t,timer_end:endTimers[i]}}))
		} else {
			setItemTimers([])
		}
	},[item,playerInventory])

	return <Row className={"pb-1 pt-1 text-light"+(Number(item.obtained)===0?item.finalcraft?" finalProduct":" notStarted":Number(item.obtained)===Number(item.required)?" completed":" inProgress")}>
			<Col>
				<img src={"https://xivapi.com"+item.icon} alt={item.name}/> {item.name}  <sub className="text-muted" style={{marginLeft:"10px"}}>{itemLoc}</sub>
			</Col>
			<Col>
				<input disabled={lockout} name={"field_"+item.id} style={{width:"5em"}} defaultValue={item.obtained} className="mt-1 bg-secondary"
				onKeyDown={(k)=>{
					if (k.key==='Enter') {for (var field of document.getElementsByName("field_"+item.id)){
						updateItem(item,field,contributor)
					}}
				}}
				onChange={(f)=>{
					if (f.currentTarget.value>=item.required) {f.currentTarget.blur()} 
				}} onBlur={(f)=>{updateItem(item,f.currentTarget,contributor)}} type="number" min="0" max={item.required}/> / {item.required} {item.required!==item.obtained&&<FaCheckCircle style={{color:"green"}} onClick={(f)=>{
					updateItem(item,{value:item.required},contributor)
				}}/>}
			</Col>
			{item.required!==item.obtained&&<>
			<Col sm={2}>
				<a style={{position:"relative",top:"8px"}} className="text-muted" href={"https://garlandtools.org/db/#item/"+item.itemid} target="tools">View Item Info</a>
			</Col>
			<Col sm={1}>
				<BiAlarmAdd style={{cursor:"pointer",borderBottom:"1px dotted",color:"#99FF99"}} onClick={()=>{if (item.timer_start!==null&&item.timer_start.length>0){updateTimer("0:00","3:00",item.timer_start.split(",").length)} else {updateTimer("0:00","3:00",0)}}}/>
			</Col>
			<Col sm={3}>
				{itemTimers.map((timer,i)=><Timer key={i} lockout={lockout} updateTimer={updateTimer} timerIndex={i} timer_start={timer.timer_start} timer_end={timer.timer_end}/>)}
			</Col></>}
			</Row>
}

function Timer(p){
	const {timer_start,timer_end,timerIndex,updateTimer,lockout}=p
	const [timerStart,setTimerStart] = useState("")
	const [timerEnd,setTimerEnd] = useState("")
	useEffect(()=>{
		setTimerStart(timer_start)
		setTimerEnd(timer_end)
	},[timer_start,timer_end])
	return <Row>
		<Col sm={3}><DarkInput style={{width:"100%"}} disabled={lockout} value={timerStart} onChange={(f)=>{setTimerStart(f.currentTarget.value)}} onKeyDown={(k)=>{if (k.key==='Enter') {if (k.currentTarget.value!=timer_start){updateTimer(k.currentTarget.value,timer_end,timerIndex)}}}} onBlur={(f)=>{if (f.currentTarget.value!=timer_start){updateTimer(f.currentTarget.value,timer_end,timerIndex)}}}></DarkInput></Col>
		<Col sm={1} className="text-white">-</Col>
		<Col sm={3}><DarkInput style={{width:"100%"}} disabled={lockout} value={timerEnd} onChange={(f)=>{setTimerEnd(f.currentTarget.value)}} onKeyDown={(k)=>{if (k.key==='Enter') {if (k.currentTarget.value!=timer_end){updateTimer(timer_start,k.currentTarget.value,timerIndex)}}}} onBlur={(f)=>{if (f.currentTarget.value!=timer_end){updateTimer(timer_start,f.currentTarget.value,timerIndex)}}}></DarkInput></Col>
		<Col sm={1}><MdAlarmOff style={{cursor:"pointer",color:"red"}} onClick={(f)=>{updateTimer("","",timerIndex)}}/></Col>
	</Row>
}

function ItemGroup(p) {
	const { data } = p
	const { contributor,itemCount,totalItemCount,playerInventory,lockout,setLockout } = p
	const [displayData,setDisplayData] = useState([])
	
	useEffect(()=>{
		setDisplayData([...data].sort((a,b)=>{
			if (b.required===b.obtained&&a.required!==a.obtained) {return -1}
			if (b.required===b.obtained&&a.required===a.obtained) {return a.id-b.id}
			if (b.required!==b.obtained&&a.required!==a.obtained) {return a.id-b.id}
			return 0
		}))
	},[data])

	useEffect(()=>{
		displayData.forEach((item)=>{
			if (document.getElementsByName("field_"+item.id).length>0) {
				for (var field of document.getElementsByName("field_"+item.id)){
					field.value=item.obtained
				}
			}
		})
	},[displayData])
	
	return <Accordion.Item className="bg-dark" eventKey={p.akey}>
				<Accordion.Header className="panel-body bg-dark">{p.name}</Accordion.Header>
				<Accordion.Body className="panel-body">
				  {displayData.map((item,i,arr)=><Item key={item.id} item={item} setLockout={setLockout} lockout={lockout} contributor={contributor} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}></Item>)}
				</Accordion.Body>
			  </Accordion.Item>
}

function Notification(p) {

	const [show,setShow] = useState(true)

	const { not } = p
	return <Toast key={not.id} show={show} autohide delay={NOTIFICATIONTIMEOUT*1000} onClose={()=>{setShow(false)}} bg={(not.operation==="FINISH"||not.operation==="FINISH_CRAFT")?"success":not.operation==="INCREASE"?"primary":"warning"}>
	<Toast.Header closeButton={true}>
	<span className="me-auto">
		<strong>{not.username}</strong>
		{not.operation==="FINISH_CRAFT"?" has finished crafting "+not.item_name+"!":
		not.operation==="FINISH"?" has finished collecting "+not.required+" "+not.item_name+"!":
		not.operation==="INCREASE"?" has collected "+not.obtained+"/"+not.required+" "+not.item_name+" (+"+(not.obtained-not.previous_amt)+")"
		:" has set "+not.item_name+"  to "+not.obtained+"/"+not.required}</span>
	</Toast.Header>
</Toast>
}

function DarkInput(p){
	return <input type="text" className="bg-dark text-white" {...p}></input>
}
function DarkSelect(p){
	return <select className="bg-dark text-white" {...p}>{p.children}</select>
}

function ListApp(p){

	//https://xivapi.com/search?filters=ClassJob.ID=11,RecipeLevelTable.ClassJobLevel%3E=36,RecipeLevelTable.ClassJobLevel%3C=45&page=1
	const {transferItems} = p
	const [groceryList,setGroceryList] = useState([])

	const crafters=["CRP Carpenter","BSM Blacksmith","ARM Armorer","GSM Goldsmith","LTW Leatherworker","WVR Weaver","ALC Alchemist","CUL Culinarian"]
	const [selectedCrafter,setSelectedCrafter] = useState(0)
	const [minLevel,setMinLevel] = useState(1)
	const [maxLevel,setMaxLevel] = useState(10)
	const [playerInventory,setPlayerInventory] = useState([])
	const [saddlebagInventory,setSaddlebagInventory] = useState([])
	const [r1Inventory,setR1Inventory] = useState([])
	const [r2Inventory,setR2Inventory] = useState([])
	const [r3Inventory,setR3Inventory] = useState([])
	const [r4Inventory,setR4Inventory] = useState([])
	const [r5Inventory,setR5Inventory] = useState([])
	const [r6Inventory,setR6Inventory] = useState([])
	const [r7Inventory,setR7Inventory] = useState([])
	const [r8Inventory,setR8Inventory] = useState([])
	const [r9Inventory,setR9Inventory] = useState([])
	const [checking,setChecking] = useState(false)
	const [lastUpdate,setLastUpdate] = useState(0)

	function sleep(ms) {
		return new Promise(resolve => setTimeout(resolve, ms));
	}

	useEffect(()=>{
		const interval = setInterval(()=>{
			axios.get("http://projectdivar.com/inventoryData?lastUpdate="+lastUpdate)
			.then((data)=>{
				if (data.data.length>0){
					setLastUpdate(new Date().getTime())
					for (var i=0;i<data.data.length;i++){
						var inventory=data.data[i]
						if (i==0){
							var plInven=[]
							var sbInven=[]
							for (var j=0;j<140;j++){
								plInven=[...plInven,inventory[j]]
							}
							for (var j=140;j<inventory.length;j++){
								sbInven=[...sbInven,inventory[j]]
							}
							setPlayerInventory(plInven)
							setSaddlebagInventory(sbInven)
						} else {
							switch(i){
								case 1:{
									setR1Inventory(inventory)
								}break;
								case 2:{
									setR2Inventory(inventory)
								}break;
								case 3:{
									setR3Inventory(inventory)
								}break;
								case 4:{
									setR4Inventory(inventory)
								}break;
								case 5:{
									setR5Inventory(inventory)
								}break;
								case 6:{
									setR6Inventory(inventory)
								}break;
								case 7:{
									setR7Inventory(inventory)
								}break;
								case 8:{
									setR8Inventory(inventory)
								}break;
								case 9:{
									setR9Inventory(inventory)
								}break;
							}
						}
					}
				}
			})
			.catch((err)=>{/*console.error("Couldn't read inventory data. "+JSON.stringify(err))*/})
		},1000)
		return ()=>clearInterval(interval)
	})

	function submitForm(){
		let classID=Number(selectedCrafter)+8
		let filter="https://xivapi.com/search?filters=ClassJob.ID="+classID+",RecipeLevelTable.ClassJobLevel>="+minLevel+",RecipeLevelTable.ClassJobLevel<="+maxLevel
		let pageCount=0
		let currentPage=1
		let recipeData=[]
		setChecking(true)
		setGroceryList([])
		axios.get(encodeURI(filter))
		.then(async(resp)=>{
			let data=resp.data
			let pageCount=data.Pagination.PageTotal
			let results=data.Results
			while (currentPage<=pageCount){
				for (let recipe of results){
					axios.get(encodeURI("https://xivapi.com"+recipe.Url))
					.then((resp)=>{
						let d = resp.data
						recipeData=[d,...recipeData]
					})
					.catch((err)=>{/*console.error("Failed to get recipe. "+JSON.stringify(err))*/})
					await sleep(250)
				}
				currentPage++;
				if (currentPage>pageCount){
					break;
				}
				await axios.get(encodeURI(filter+"&page="+currentPage))
				.then((resp)=>{
					let d=resp.data
					results=d.Results
				})
				.catch((err)=>{/* console.error("Failed to get recipe. "+JSON.stringify(err)) */})
			}
		})
		.catch((err)=>{/* console.error("Failed to get recipe. "+JSON.stringify(err)) */})
		.finally(async()=>{
			//console.log(recipeData)
			//setChecking(false)
			let craftedItems={}
			for(var recipe of recipeData){
				for (let i=0;i<=5;i++){
					var ingredient=recipe["ItemIngredient"+i]
					var amount=recipe["AmountIngredient"+i]
					if (ingredient!==null){
						if (ingredient.Name.includes("Component Materials")||ingredient.Name.includes("Skybuilders'")){continue}
						if (ingredient.Name in craftedItems){
							let oldItem=craftedItems[ingredient.Name];
							oldItem.amt+=Number(amount)
							craftedItems[ingredient.Name]=oldItem
						} else {
							craftedItems[ingredient.Name]={...ingredient,"amt":Number(amount)}
						}
					}
				}
			}
			let retainerItems=[[],[],[],[],[],[],[],[],[],[]]
			for (var item of Object.keys(craftedItems)){
				let found=false
				let retainerArray=[r1Inventory,r2Inventory,r3Inventory,r4Inventory,r5Inventory,r6Inventory,r7Inventory,r8Inventory,r9Inventory]
				for (var i=0;i<retainerArray.length;i++){
					for (var j=0;j<retainerArray[i].length;j++){
						let it = retainerArray[i][j]
						if (it.name===item){
							var targetItem={...it}
							targetItem.amt=craftedItems[item].amt
							targetItem.hq=false
							targetItem.slot=j
							retainerItems[i]=[targetItem,...retainerItems[i]]
							found=true
							break; 
						}
					}
					if (found){
						break;
					}
				}
				if (found===false){
					console.log(JSON.stringify(craftedItems[item])+" not found. Adding as "+JSON.stringify({"icon":craftedItems[item].Icon,"id":craftedItems[item].ID,"name":craftedItems[item].Name,"amt":craftedItems[item].amt,"hq":false}))
					retainerItems[9]=[{"icon":craftedItems[item].Icon,"id":craftedItems[item].ID,"name":craftedItems[item].Name,"amt":craftedItems[item].amt,"hq":false},...retainerItems[9]]
				}
			}
			for (var i=0;i<retainerItems.length-1;i++){
				retainerItems[i].sort((a,b)=>a.slot-b.slot)
			}
			setGroceryList(retainerItems)
			setChecking(false)
		})
	}

	function Item(p){
		const {it} = p
		return it.amt>0&&<Row className="text-white">
			<Col><img src={"https://xivapi.com"+it.icon}></img>{Number.isInteger(it.slot)?"["+Math.floor(it.slot/35+1)+"]":""} {it.name} x{it.amt} {it.hq?"(HQ)":""}</Col>
		</Row>
	}
	function RetainerDisplay(p){
		const {id,inventory} = p
		return <>
			<Row className="text-white"><Col><h2>{retainerNames[id]}'s Inventory</h2></Col></Row>
			{inventory.map((item,i)=><Item it={item} key={i}></Item>)}
		</>
	}

	return <>
		<Row className="text-white">
			<Col xs={4}>
				<DarkSelect value={selectedCrafter} onChange={(f)=>{setSelectedCrafter(f.currentTarget.value)}}>
					{crafters.map((crafter,i)=><option value={i} key={i}>{crafter}</option>)}
				</DarkSelect>
			</Col>

			<Col>
				Level Range:
			</Col>
			
			<Col xs={2}>
				<DarkInput value={minLevel} onChange={(f)=>{setMinLevel(f.currentTarget.value)}}></DarkInput>
			</Col>
			<Col>-</Col>
			<Col xs={2}>
				<DarkInput value={maxLevel} onChange={(f)=>{setMaxLevel(f.currentTarget.value)}}></DarkInput>
			</Col>
			<Col xs={3}>
				<Button onKeyDown={(k)=>{if (k.key==='Enter') {submitForm()}}} disabled={checking} onClick={()=>{submitForm()}}>{checking?<Spinner animation="border"></Spinner>:"Compose"}</Button>
			</Col>
			<Col xs={1}>
				
			</Col>
		</Row>
		<Row><span>A</span></Row>
		{groceryList.map((list,i)=>{
			if (list.length>0){
				return <Fragment key={i}>
					<Row className="text-white"><Col>{(i===9)?<h4 style={{"color":"#AA0000"}}>Not Found:</h4>:<h4>From {retainerNames[i]}:</h4>}</Col></Row>
					<Row className="text-white"><Col>
						<ul>
							{list.map((item,j)=><li key={j}><Item it={item}></Item></li>)}	
						</ul>
					</Col></Row>
				</Fragment>
			}
		})}
		<Row><span>Inventories</span></Row>
		<Row className="text-white"><Col><h2>Player Inventory</h2></Col></Row>
		{playerInventory.map((item,i)=><Item it={item} key={i}></Item>)}
		<Row className="text-white"><Col><h2>Chocobo Saddlebag Inventory</h2></Col></Row>
		{saddlebagInventory.map((item,i)=><Item it={item} key={i}></Item>)}
		<RetainerDisplay id={0} inventory={r1Inventory}></RetainerDisplay>
		<RetainerDisplay id={1} inventory={r2Inventory}></RetainerDisplay>
		<RetainerDisplay id={2} inventory={r3Inventory}></RetainerDisplay>
		<RetainerDisplay id={3} inventory={r4Inventory}></RetainerDisplay>
		<RetainerDisplay id={4} inventory={r5Inventory}></RetainerDisplay>
		<RetainerDisplay id={5} inventory={r6Inventory}></RetainerDisplay>
		<RetainerDisplay id={6} inventory={r7Inventory}></RetainerDisplay>
		<RetainerDisplay id={7} inventory={r8Inventory}></RetainerDisplay>
		<RetainerDisplay id={8} inventory={r9Inventory}></RetainerDisplay>
	</>
}

function TimeDisplay(duration){
	var hrs=Math.floor(duration/3600)
	var min=Math.floor(duration/60)%60
	return (hrs>0?hrs+" hrs,":"")+min+" min"
}

function TimerDisplay(p){
	const {timer,eorzeanTime} = p
	var eorzeanSeconds=Number(eorzeanTime.split(":")[0])*3600+Number(eorzeanTime.split(":")[1])*60
	return <><Row>
		<Col sm={8}>
		<img src={"https://xivapi.com"+timer.icon}/> {timer.name} <sub><i style={{color:"gray"}}>{eorzeanSeconds>timer.actual_seconds&&eorzeanSeconds<timer.end_seconds?"Node Available: "+TimeDisplay(timer.end_seconds-eorzeanSeconds):TimeDisplay((eorzeanSeconds>timer.actual_seconds)?timer.actual_seconds+86400-eorzeanSeconds:timer.actual_seconds-eorzeanSeconds)}</i></sub>
		</Col>
		<Col sm={4}>
		<span style={{position:"relative",top:"12px",float:"right"}}>{timer.timer_start} - {timer.timer_end}</span>
		</Col>
	</Row>
	<Row>
		<Col sm={1}/>
		<Col sm={10}>
			<ProgressBar variant={eorzeanSeconds>timer.actual_seconds&&eorzeanSeconds<timer.end_seconds?"success":""} animated={eorzeanSeconds>timer.actual_seconds&&eorzeanSeconds<timer.end_seconds} striped={eorzeanSeconds>timer.actual_seconds&&eorzeanSeconds<timer.end_seconds} now={eorzeanSeconds>timer.actual_seconds?eorzeanSeconds<timer.end_seconds?100-((eorzeanSeconds-timer.end_seconds)/(timer.seconds-timer.end_seconds))*100:((eorzeanSeconds-timer.actual_seconds)/864):(100-(timer.actual_seconds-eorzeanSeconds)/864)}></ProgressBar>
		</Col>
	</Row>
	</>
}

function App() {
	
	const [data,setData] = useState([])
	const [data2,setData2] = useState([])
	const [data3,setData3] = useState([])
	const [data4,setData4] = useState([])
	const [fileData,setFileData] = useState()
	const [fileData2,setFileData2] = useState()
	const [update,setUpdate] = useState(true)
	const [succeeded,setSucceeded] = useState(0)
	const [failed,setFailed] = useState(0)
	const [total,setTotal] = useState(0)
	const [itemCount,setItemCount] = useState()
	const [totalItemCount,setTotalItemCount] = useState()
	const [craftsRatio,setCraftsRatio] = useState(0)
	const [inProgressRatio,setInProgressRatio] = useState(0)
	const [missingProgressRatio,setMissingProgressRatio] = useState(0)
	const [completeRatio,setCompleteRatio] = useState(0)
	const [lastModified,setLastModified] = useState(new Date())
	const [lastUpdate,setLastUpdate] = useState(0)
	const [playerInventory,setPlayerInventory] = useState([])
	const [eorzeanTime,setEorzeanTime] = useState("")
	const [timerList,setTimerList] = useState([])
	const [timerCutList1,setTimerCutList1] = useState([])
	const [timerCutList2,setTimerCutList2] = useState([])

	const [contributor,setContributor] = useState("")
	const [notifications,setNotifications] = useState([])

	const [nav,setNav] = useState("main")

	const [transferItems,setTransferItems] = useState([])

	const [matchedItems,setMatchedItems] = useState([])

	//const [lockout,setLockout] = useState(false)

	function LZ(digits,numb) {
		return "0".repeat(digits-String(numb).length)+numb
	}

	useEffect(()=>{
		var eorzeanSeconds=Number(eorzeanTime.split(":")[0])*3600+Number(eorzeanTime.split(":")[1])*60
		var timerObjs=timerList.map((item)=>{
			var seconds=Number(item.timer_start.split(":")[0])*3600+Number(item.timer_start.split(":")[1])*60
			var originalSeconds=seconds
			var endSeconds=Number(item.timer_end.split(":")[0])*3600+Number(item.timer_end.split(":")[1])*60
			if (endSeconds<seconds&&eorzeanSeconds>=0&&eorzeanSeconds<seconds){
				seconds=0
			}
			return {seconds:seconds,actual_seconds:originalSeconds,end_seconds:endSeconds,...item}}).sort((a,b)=>a.end_seconds-b.end_seconds)
		setTimerCutList1(timerObjs.filter((timer)=>timer.end_seconds>=eorzeanSeconds))
		setTimerCutList2(timerObjs.filter((timer)=>timer.end_seconds<eorzeanSeconds))
	},[timerList,eorzeanTime])
	
	useEffect(()=>{
		const interval = setInterval(()=>{
			axios.get(BACKEND_URL+"/lastUpdate")
			.then((data)=>{
				if (new Date(data.data[0].last_modified)>lastModified) {
					console.log("Updating entries... "+[lastModified,data.data[0].last_modified])
					setLastModified(new Date())
					return axios.get("https://projectdivar.com:4505/getData")
					.then((data)=>{
						//setData(data.data)
						var timers=[]
						var timerItems=data.data.filter((item)=>item.obtained!=item.required&&item.timer_start!=null&&item.timer_start.length>0)
						for (item of timerItems){
							var splitter=item.timer_start.split(",")
							var splitter2=item.timer_end.split(",")
							var i=0
							for (var t of splitter){
								var newItem={...item}
								newItem.timer_start=t
								newItem.timer_end=splitter2[i++]
								timers=[...timers,newItem]
							}
						}
						setTimerList(timers)
						setData(data.data.slice(dataSplitters[0],dataSplitters[1]))
						setData2(data.data.slice(dataSplitters[1],dataSplitters[2]))
						setData3(data.data.slice(dataSplitters[2],dataSplitters[3]))
						let finalItems=data.data.slice(dataSplitters[0],dataSplitters[3])
						let tempFinalItems=data.data.slice(dataSplitters[3],data.data.length)
						let itemsComplete=0,itemsInProgress=0,itemsCrafts=0,tot=0,totItemsInProgress=0,totCrafts=0
						for(var i=0;i<tempFinalItems.length;i++){
							if (tempFinalItems[i].required==tempFinalItems[i].obtained){
								itemsCrafts+=Number(tempFinalItems[i].required)
							}
							totCrafts+=Number(tempFinalItems[i].required)
							tot+=Number(tempFinalItems[i].required)
							tempFinalItems[i]={...tempFinalItems[i],"finalcraft":true}
						}
						setData4(tempFinalItems)
						for (var item of finalItems){
							if (item.required==item.obtained){
								itemsComplete+=Number(item.required)
							} else
							if (item.obtained>0){
								itemsInProgress+=Number(item.obtained)
								totItemsInProgress+=Number(item.required)
							}
							tot+=Number(item.required)
						}
						setItemCount(itemsComplete+itemsInProgress+itemsCrafts)
						setTotalItemCount(tot)
						setMissingProgressRatio((((totItemsInProgress-itemsInProgress)+(totCrafts-itemsCrafts))/tot*100).toFixed(2))
						setCompleteRatio((itemsComplete/tot*100).toFixed(2))
						setInProgressRatio((itemsInProgress/tot*100).toFixed(2))
						setCraftsRatio((itemsCrafts/tot*100).toFixed(2))
					})
					.catch((err)=>{/* console.error("Failed to download recipes. "+JSON.stringify(err)) */})
				}
			})
			.catch((err)=>{
				console.log(err.message)
			})
		},1000)
		return ()=>clearInterval(interval)
	},[lastModified])

	useEffect(()=>{
		const interval = setInterval(()=>{
			if (nav==="main"){
				axios.get("http://projectdivar.com/inventoryData?lastUpdate="+lastUpdate)
				.then((data)=>{
					if (data.data.length>0){
						setLastUpdate(new Date().getTime())
						setPlayerInventory(data.data)
					}
				})
				.catch((err)=>{/* console.error("Failed to download player inventory data. "+JSON.stringify(err)) */})
			}
		},1000)
		return ()=>clearInterval(interval)
	},[nav,lastUpdate])

	useEffect(()=>{
		const interval = setInterval(()=>{
			if (nav==="main"){
				var date=new Date()
				var earthH=date.getHours(),earthM=date.getMinutes(),earthS=date.getSeconds()
				var earthTime=Number(earthH)*3600+Number(earthM)*60+Number(earthS)
				var eorzeanTime=earthTime*20.571428571428571428571428571429+49380
				var eorzeanH=Math.floor(eorzeanTime/3600)%24
				var eorzeanM=Math.floor(eorzeanTime/60)%60
				var eorzeanS=Math.floor(eorzeanTime)%60
				setEorzeanTime((("0")+eorzeanH).slice(-2)+":"+(("0")+eorzeanM).slice(-2))
			}
		},3000)
		return ()=>clearInterval(interval)
	},[nav,lastUpdate])

	useEffect(()=>{
		var notificationLastUpdate = new Date(new Date()-(NOTIFICATIONTIMEOUT*1000))
		var largestNotificationID = -1
		var dataCheck=true
		const interval = setInterval(()=>{
			if (dataCheck&&nav==="main") {
				dataCheck=false
				notificationLastUpdate = new Date(new Date()-(NOTIFICATIONTIMEOUT*1000))
				axios.get(BACKEND_URL+"/getNotifications?date="+encodeURIComponent(LZ(4,notificationLastUpdate.getUTCFullYear())+"-"+LZ(2,notificationLastUpdate.getUTCMonth()+1)+"-"+LZ(2,notificationLastUpdate.getUTCDate())+" "+LZ(2,notificationLastUpdate.getUTCHours())+":"+LZ(2,notificationLastUpdate.getUTCMinutes())+":"+LZ(2,notificationLastUpdate.getUTCSeconds())+"."+LZ(3,notificationLastUpdate.getUTCMilliseconds())+"+00"))
				.then((data)=>{
					if (data.data.length>0) {
						//console.log("New notification array: "+JSON.stringify(data.data))
						setNotifications(data.data)
						var completion=false
						var largestID = -1
						for (var dat of data.data) {
							if (dat.id>largestNotificationID && dat.operation==="FINISH") {
								completion=true
								largestID=Math.max(dat.id,largestID)
								break
							} else 
							if (dat.id>largestNotificationID)
							{
								largestID=Math.max(dat.id,largestID)
							}
						}
						if (largestID!==-1) {	
							largestNotificationID = largestID
							if (completion) {progress2.play()} else {progress1.play()}
						}
					}
				})
				.catch((err)=>{
					console.log(err.message)
				})
				.then(()=>{
					dataCheck=true
				})
			}
		},1000)
		return ()=>clearInterval(interval)
	},[nav])
	
	const disabled=false
	
	useEffect(()=>{
		if (update) {
			axios.get("https://projectdivar.com:4505/getData")
			.then((data)=>{
				//setData(data.data)
				var timers=[]
				var timerItems=data.data.filter((item)=>item.obtained!=item.required&&item.timer_start!=null&&item.timer_start.length>0)
				for (item of timerItems){
					var splitter=item.timer_start.split(",")
					var splitter2=item.timer_end.split(",")
					var i=0
					for (var t of splitter){
						var newItem={...item}
						newItem.timer_start=t
						newItem.timer_end=splitter2[i++]
						timers=[...timers,newItem]
					}
				}
				setTimerList(timers)
				setData(data.data.slice(dataSplitters[0],dataSplitters[1]))
				setData2(data.data.slice(dataSplitters[1],dataSplitters[2]))
				setData3(data.data.slice(dataSplitters[2],dataSplitters[3]))
				let finalItems=data.data.slice(dataSplitters[0],dataSplitters[3])
				let tempFinalItems=data.data.slice(dataSplitters[3],data.data.length)
				let itemsComplete=0,itemsInProgress=0,itemsCrafts=0,tot=0,totItemsInProgress=0,totCrafts=0
				for(var i=0;i<tempFinalItems.length;i++){
					if (tempFinalItems[i].required==tempFinalItems[i].obtained){
						itemsCrafts+=Number(tempFinalItems[i].required)
					}
					totCrafts+=Number(tempFinalItems[i].required)
					tot+=Number(tempFinalItems[i].required)
					tempFinalItems[i]={...tempFinalItems[i],"finalcraft":true}
				}
				setData4(tempFinalItems)
				for (var item of finalItems){
					if (item.required==item.obtained){
						itemsComplete+=Number(item.required)
					} else
					if (item.obtained>0){
						itemsInProgress+=Number(item.obtained)
						totItemsInProgress+=Number(item.required)
					}
					tot+=Number(item.required)
				}
				setItemCount(itemsComplete+itemsInProgress+itemsCrafts)
				setTotalItemCount(tot)
				setMissingProgressRatio((((totItemsInProgress-itemsInProgress)+(totCrafts-itemsCrafts))/tot*100).toFixed(2))
				setCompleteRatio((itemsComplete/tot*100).toFixed(2))
				setInProgressRatio((itemsInProgress/tot*100).toFixed(2))
				setCraftsRatio((itemsCrafts/tot*100).toFixed(2))
			})
			.catch((err)=>{
				console.log(err.message)
				setData([
					{id:1726,itemid:2,name:"Fire Shard",icon:"/i/020000/020001.png",obtained:694,required:4124},
					{id:1727,itemid:3,name:"Ice Shard",icon:"/i/020000/020003.png",obtained:0,required:1226},
					{id:1728,itemid:4,name:"Wind Shard",icon:"/i/020000/020004.png",obtained:4719,required:4719},
					{id:1729,itemid:5,name:"Earth Shard",icon:"/i/020000/020006.png",obtained:15,required:1764},
					{id:1730,itemid:6,name:"Lightning Shard",icon:"/i/020000/020005.png",obtained:0,required:2374},
				])
			})
			setUpdate(false)
		}
	},[update])
	
	useEffect(()=>{
		if (succeeded+failed===total) {
			setUpdate(true)
		}
	},[succeeded,failed,total])
	
	useEffect(()=>{
	
		const downloadData=(d,val,max)=>{
			if (val<max) {
				axios.get(encodeURI("https://xivapi.com/search?string="+d[val].Item))
					.then((data)=>{
						var results = data.data.Results
						var found=false
						for (var r of results) {
							if (r.Name===d[val].Item&&r.UrlType==="Item") {
								found=true
								//console.log("Found "+r)
								setSucceeded(succeeded+1)
								var dataObj = {
									itemid:r.ID,
									name:r.Name,
									obtained:0,
									required:d[val].Needed,
									icon:r.Icon
								}
								return axios.post(BACKEND_URL+"/setItem",dataObj)
							}
						}
						if (!found) {
							setFailed(failed+1)
							console.log("Could not find "+d[val].Item+"....")
						}
					})
					.then(()=>{
						setTimeout(downloadData(d,val+1,max),250)
					})
					.catch((err)=>{
						setFailed(failed+1)
					})
			}
		}

		var d = parse(fileData,{columns:true,skip_empty_lines:true})
		console.log(d)
		downloadData(d,0,d.length)
		setTotal(d.length)
	},[fileData])

	useEffect(()=>{
	
		const downloadData=(d,val,max)=>{
			if (val<max) {
				axios.post(BACKEND_URL+"/addItem",d[val])
				.then((data)=>{
					setTimeout(downloadData(d,val+1,max),250)
				})
				.catch((err)=>{/*console.error("Failed to download. "+JSON.stringify(err))*/})
			}
		}

		var d = parse(fileData2,{columns:true,skip_empty_lines:true})
		console.log(d)
		downloadData(d,0,d.length)
	},[fileData2])

	function Importer(){
		return <Row>
			<Col>
			{total===0?<caption><label className="buttonLabel" for="uploads">Import List</label><input onChange={(f)=>{
					const reader = new FileReader()
					reader.onload=(ev)=>{
						setFileData(ev.target.result)
					}
					reader.readAsText(f.target.files[0])
			}} style={{opacity:0}} id="uploads" type="file" accept=".txt,.csv"/></caption>:
				<>
					<ProgressBar>
					<ProgressBar animated striped variant="success" now={Math.round(succeeded/total)*100} />
					<ProgressBar animated striped variant="danger" now={Math.round(failed/total)*100} />
					</ProgressBar>
					<div className="text-center">{Math.round(((failed+succeeded)/total)*100)+"%"}</div>
				</>
			}
			</Col>
		</Row>
	}

	function updateSearch(val){
		if (val.length>2){
			setMatchedItems(fuzzysort.go(val.trim().toLowerCase(), [...data,...data2,...data3,...data4], {key:'name'}))
		} else
		if (val.length==0){
			setMatchedItems([])
		}
	}
	
  return (  
	  <Container className="bg-dark" fluid>
		  <Navbar bg="dark" variant="dark">
			  <Container fluid>
				<Navbar.Brand href="#home">
				  <img src={process.env.PUBLIC_URL+"/favicon.ico"} width="30" height="30" className="d-inline-block align-top" alt="BUN logo"/> BUN Collab App
				</Navbar.Brand>
				{contributor.length>0&&<>
				<Nav.Link style={(nav==="main")?{"color":"lime","textDecoration":"underline"}:{}} onClick={()=>{setNav("main")}}>Main</Nav.Link>
				<Nav.Link style={(nav==="list")?{"color":"lime","textDecoration":"underline"}:{}} onClick={()=>{setNav("list")}}>Grocery List</Nav.Link>
				<span className="text-light font-weight-light font-italic">Signed in as {contributor}</span>
				</>}
			  </Container>
		  </Navbar>
			<Container fluid>
				<Row>
					<Col sm={1}></Col>
					<Col sm={8}>
						{contributor.length===0?<>
									<input placeHolder="e.g. Bun" onKeyDown={(k)=>{if (k.key==='Enter') {setContributor(document.getElementById("username").value)}}} id="username"/>
									<button type="Submit" onClick={(f)=>{setContributor(document.getElementById("username").value)}}>Submit</button>
								</>:
								nav==="main"?
									data.length>0?
									<>
										<Row><Col className="text-white">
											<span style={{fontSize:"2em",paddingRight:"10px"}}>{Math.floor(Number(completeRatio)+Number(inProgressRatio)+Number(craftsRatio))}% complete</span><sub>({itemCount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",") + " / " + totalItemCount.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",")})</sub>
										</Col></Row>
										<Row>
											<ProgressBar className="bg-dark text-white">
												<ProgressBar animated striped variant="success" label={`${completeRatio}%`} now={completeRatio} />
												<ProgressBar animated striped variant="info" label={`${inProgressRatio}%`} now={inProgressRatio} />
												<ProgressBar animated striped variant="danger" label={`${craftsRatio}%`} now={craftsRatio} />
												<ProgressBar animated striped variant="dark" now={missingProgressRatio} />
											</ProgressBar>
										</Row>
										<Row>
											<Form>
												<Form.Group className="mb-3">
													<Form.Control id="searchBar" className="bg-dark text-white" type="text" placeholder="Search Item" onChange={(f)=>{
														updateSearch(f.currentTarget.value)
													}} />
													{matchedItems.map((item)=><Item key={item.obj.id} item={item.obj} contributor={contributor} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}></Item>)}
												</Form.Group>
											</Form>
										</Row>
										<Accordion className="bg-dark" defaultActiveKey="0">
											<ItemGroup name="Gathering Items" contributor={contributor} akey="0" data={data} lastModified={lastModified} setLastModified={setLastModified} setData={setData} setData1={setData} setData2={setData2} setData3={setData3} setData4={setData4} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}/>
											<ItemGroup name="Other Items" contributor={contributor} akey="1" data={data2} lastModified={lastModified} setLastModified={setLastModified} setData={setData2} setData1={setData} setData2={setData2} setData3={setData3} setData4={setData4} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}/>
											<ItemGroup name="Pre-crafting" contributor={contributor} akey="2" data={data3} lastModified={lastModified} setLastModified={setLastModified} setData={setData3} setData1={setData} setData2={setData2} setData3={setData3} setData4={setData4} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}/>
											<ItemGroup name="Crafting Items" contributor={contributor} akey="3" data={data4} lastModified={lastModified} setLastModified={setLastModified} setData={setData4} setData1={setData} setData2={setData2} setData3={setData3} setData4={setData4} itemCount={itemCount} totalItemCount={totalItemCount} playerInventory={playerInventory}/>
										</Accordion>
									</>:<Importer></Importer>
								:nav==="list"?<ListApp transferItems={transferItems}></ListApp>:
								<></>
							}
					<div style={{pointerEvents:"none",position:"fixed",top:"0px",left:"0px",width:"100%",height:"100%"}}>
						<ToastContainer position="bottom-end">
							{notifications.map((not)=>{
								return <Notification key={not.id} not={not}/>
							})}
						</ToastContainer>
					</div>
				</Col>
				{contributor.length>0&&
					<Col sm={3} className="text-white">
						<span style={{fontSize:24,marginRight:"24px"}}>Timers</span><i>ET: {eorzeanTime}</i>
						{timerCutList1.map((timer,i)=><TimerDisplay timer={timer} key={i} eorzeanTime={eorzeanTime}/>)}
						{timerCutList2.map((timer,i)=><TimerDisplay timer={timer} key={i} eorzeanTime={eorzeanTime}/>)}
					</Col>
				}
			</Row>
		</Container>
	  </Container>
  );
}

export default App;
